#include "stdafx.h"

#include "Weightedaverage.h"

void WeightedAverage::averageplane_P4(int plane, IScriptEnvironment* env)
{
	if (length > 32) 
		env->ThrowError("Optimised WeightedAverage can only process 32 frames.");
	if (length%2==1)
		env->ThrowError("Optimised WeightedAverage requires even number of frames.");
	for (int i=0;i<length;++i)
		if ( scaledweight[i] != short (scaledweight[i]) )
			env->ThrowError("Optimised WeightedAverage weight coefficients too large.");

	_declspec(align(16)) const unsigned char* sourcep[64];
     for (int i=0;i<length;++i)
               sourcep[i] = source[i]->GetReadPtr(plane);
	//for (int i=0;i<length/2;++i)
	//{
	//	sourcep[4*i] = source[2*i]->GetReadPtr(plane);
	//	sourcep[4*i+1] = source[2*i+1]->GetReadPtr(plane);
	//}
	unsigned char* resultp = result->GetWritePtr(plane);

	const int width = source[0]->GetRowSize(plane);
	const int height = source[0]->GetHeight(plane);

	/*const*/ int source_pitch[32];
	for (int i=0;i<length;++i)
		source_pitch[i] = source[i]->GetPitch(plane);
	const int result_pitch = result->GetPitch(plane);

	_declspec(align(16)) int rounder[4];
	for (int j=0;j<4;++j)
		rounder[j] = scale/2;

	_declspec(align(16)) short multiplier[16*8];
	for (int i=0;i<length/2;++i)
		for (int j=0;j<8;j+=2)
		{
			multiplier[i*8 + j]      = short (scaledweight[2*i]);
			multiplier[i*8 + j+1]   = short (scaledweight[2*i+1]);
		}

	//const int length8 = length*8;
	       const int length4 = length*4;
const int eightwidth = (width% 8 == 0) ? width : (width + 8 - (width% 8));

	for (int y = 0; y < height; ++y)
	{//*	
		 __asm
		 {
			  mov     ebx, [eightwidth]//
			  mov     edi, [resultp]//
			  pxor    xmm7, xmm7
spatial:
			  movdqa  xmm4, [rounder]
			  movdqa  xmm5, [rounder]

			  mov     eax, [length4]//
temporal:
			  mov     ecx, [sourcep+eax-8]
			  mov     edx, [sourcep+eax-4]
			  movq    xmm0, mmword ptr [ecx+ebx-8]    //ecx points to frame n
			  movq    xmm1, mmword ptr [edx+ebx-8]    //edx points to frame n+1

			  movdqa  xmm3, [multiplier+2*eax-16]     //multiplier
			  punpcklbw xmm0, xmm1
			  pshufd  xmm1, xmm0, 0x4e
			  punpcklbw xmm0, xmm7
			  punpcklbw xmm1, xmm7

			  pmaddwd xmm0, xmm3
			  pmaddwd xmm1, xmm3
			sub     eax, 8
			  paddd   xmm4, xmm0
			  paddd   xmm5, xmm1

			jnz      temporal
			  //now have eight pixels worth of result in DWORDs of xmm5:xmm4

			  psrad   xmm4, 8+6
			  psrad   xmm5, 8+6
			  packssdw xmm4, xmm5
			  pmaxsw  xmm4, xmm7//necessarily*** open?
			  //now have eight pixels worth of result in WORDs of xmm4

			  packuswb xmm4, xmm7
			  movq    mmword ptr  [edi+ebx-8], xmm4

			  sub     ebx, 8
			  jnz      spatial

		 }//*/
		 for (int i=0;i<length;++i)
			  sourcep[i] += source_pitch[i];
		 resultp += result_pitch;
	}
}
